#!/bin/bash

#NASTAVENIE PREMENNYCH
#TESTED_PROGRAM=$1
TESTED_PROGRAM=u6-3

TESTED_PROGRAM_OUTPUT=tested_program_output.txt
STRACE_OUTPUT="strace_out.txt"


NUMBER_OF_STEPS=2
CURRENT_STEP=0
PASSED_STEPS=0

#PRIPRAVA SUBOROV


echo
echo "Testovanie ulohy u6-3 z cvicenia 3"
echo

#SPUSTENIE TESTOVANEHO PROGRAMU - ZISKANIE VYPISU VOLANYCH SLUZIEB
strace -e umask -o $STRACE_OUTPUT ./$TESTED_PROGRAM  > $TESTED_PROGRAM_OUTPUT 2>&1

#PRIPRAVA TESTOV
test(){

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zmeny masky prav"
if grep -q -e "^umask(077)" $STRACE_OUTPUT; then
	echo "OK - Sluzba umask() bola zavolana so spravnym parametrom."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na zmenu masky prav nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie nastavenia povodnej masky prav"
if grep -q -e "^umask(002)" $STRACE_OUTPUT; then
	echo "OK - Sluzba umask() bola zavolana so spravnym parametrom."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na zmenu masky prav nebola zavolana alebo jej boli zadane nespravne parametre."
fi

}

#ZAVOLANIE TESTU
test

#VYHODNOTENIE TESTU
echo
echo Vysledok testovania
echo "Uspesne bolo vykonanych $PASSED_STEPS / $NUMBER_OF_STEPS testov."
echo

if [ $PASSED_STEPS -eq $NUMBER_OF_STEPS ]
	then
		#ZMAZE SUBORY SO ZAZNAMAMI TESTOV
		rm $TESTED_PROGRAM_OUTPUT 
		rm $STRACE_OUTPUT
	else 
		echo
		echo "Zaznamy o teste su ulozene v suboroch:"
		echo "$STRACE_OUTPUT"
		echo "$TESTED_PROGRAM_OUTPUT"
		echo
fi

#MAZANIE VYTVORENYCH SUBOROV
rm file11.txt