#!/bin/bash

#NASTAVENIE PREMENNYCH
#TESTED_PROGRAM=$1
TESTED_PROGRAM=u1-2

TESTED_PROGRAM_OUTPUT=tested_program_output.txt
STRACE_OUTPUT="strace_out.txt"


NUMBER_OF_STEPS=2
CURRENT_STEP=0
PASSED_STEPS=0

#PRIPRAVA SUBOROV
#echo -e "jedno\nslovo\njeden\nriadok" > input_output.txt UZ JE VYTVORENY prepare-03.sh

echo
echo "Testovanie ulohy u1-2 z cvicenia 3"
echo

#SPUSTENIE TESTOVANEHO PROGRAMU - ZISKANIE VYPISU VOLANYCH SLUZIEB
strace -e dup2,dup -o $STRACE_OUTPUT ./$TESTED_PROGRAM > $TESTED_PROGRAM_OUTPUT 2>&1

#PRIPRAVA TESTOV
test01(){
# TESTOVANY 1. sposob riesenia
((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby na zduplikovanie deskriptora - vstup"
if grep -q -e "^dup2(., 0)" $STRACE_OUTPUT; then
	echo "OK - Sluzba dup2() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na zduplikovanie deskriptora nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby na zduplikovanie deskriptora - vystup"
if grep -q -e "^dup2(., 1)" $STRACE_OUTPUT; then
	echo "OK - Sluzba dup2() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na zduplikovanie deskriptora nebola zavolana alebo jej boli zadane nespravne parametre."
fi
}

test02(){
	# TESTOVANY 2. sposob riesenia
((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby na zduplikovanie deskriptora - vstup"
if grep -q -e "^dup(.)                                  = 0" $STRACE_OUTPUT; then
	echo "OK - Sluzba dup() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na zduplikovanie deskriptora nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby na zduplikovanie deskriptora - vystup"
if grep -q -e "^dup(.)                                  = 1" $STRACE_OUTPUT; then
	echo "OK - Sluzba dup() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na zduplikovanie deskriptora nebola zavolana alebo jej boli zadane nespravne parametre."
fi

}

#ZAVOLANIE TESTU
echo Test - 1. sposob
test01

#VYHODNOTENIE TESTU
echo
echo Vysledok testovania 1. sposob
echo "Uspesne bolo vykonanych $PASSED_STEPS / $NUMBER_OF_STEPS testov."
echo

#VYRIESENE 1. SPOSOBOM?
if [ $PASSED_STEPS -eq $NUMBER_OF_STEPS ]
	then
		#ZMAZE SUBORY SO ZAZNAMAMI TESTOV
		rm $TESTED_PROGRAM_OUTPUT 
		rm $STRACE_OUTPUT
	else 
		#ZAVOLANIE TESTU
		CURRENT_STEP=0
		echo Test - 2. sposob
		test02

		#VYHODNOTENIE TESTU
		echo
		echo Vysledok testovania 2. sposob
		echo "Uspesne bolo vykonanych $PASSED_STEPS / $NUMBER_OF_STEPS testov."
		echo

		if [ $PASSED_STEPS -eq $NUMBER_OF_STEPS ]
			then
				#ZMAZE SUBORY SO ZAZNAMAMI TESTOV
				rm $TESTED_PROGRAM_OUTPUT 
				rm $STRACE_OUTPUT
			else 
				echo
				echo "Zaznamy o teste su ulozene v suboroch:"
				echo "$STRACE_OUTPUT"
				echo "$TESTED_PROGRAM_OUTPUT"
				echo
		fi
fi



#MAZANIE VYTVORENYCH SUBOROV
